## 2.4.0 2024-02-24
* New: WebDAV interface
* New: WebAuthn login
* New: button to scroll to bottom in track browser
* New: show recent tracks, random tracks, or tracks with missing metadata in track browser
* New: plays by week chart
* Improve: speed up track filtering (e.g. used by track browser)
* Improve: speed up file scanner
* Improve: speed up files page
* Improve: implement resource preloading for faster page loads
* Improve: speed up Subsonic token login check
* Improve: send signal when player is closed, immediately remove from activity
* Improve: include artist and tag data in export
* Improve: highlight current row in tables in player
* Improve: wait for running tasks to complete when shutting down server
* Improve: handle moves/renames (instead of removing and then adding files)
* Improve: add labels to x and y axes for all charts
* Fix: lyrics not updating correctly when file has alternate language lyrics tags in metadata
* Fix: sorting of date values in tables
* Fix: file manager "upload file" / "create directory" buttons
* Fix: old rows not being correctly removed in activity page
* Fix: file manager using wrong URL for root directory
* Fix: missing time of day and day of week charts
* Fix: acoustid (automatic metadata discovery)
* Fix: player not loading of no previous state is saved
* Fix: sqlite WAL files keep growing
* Fix: user agent not stored for Subsonic clients
* Fix: ignore hotkeys when modifiers are pressed (e.g. don't clear queue when using Ctrl+C)
* Fix: theme color (for Safari and Chrome PWA) was set to the wrong color
* Fix: reading entire file into memory during upload
* Technical: added tests for games, account pages, static, charts, music functions, webdav, data export. Test coverage now at 71%.

## 2.3.2 2024-02-01
* New: sort table columns by clicking in header
* New: remote volume control (not yet part of UI)
* New: metrics for requests, playing/paused players
* Improve: avoid recently played artists when choosing tracks
* Improve: Subsonic: recently played and most played is now user specific
* Improve: speed up statistics loading
* Improve: speed up loading time of first track when starting player
* Fix: offline sync not updating tracks correctly
* Fix: safe handling of large body sizes in error reports
* Fix: unclosed HTTP sessions
* Technical: many code improvements and added tests

## 2.3.1 2024-01-20
* Improve: only show favorite playlists in Subsonic apps
* Fix: wait for tracks to finish syncing before exiting offline sync
* Fix: mtime and ctime mixed up
* Fix: search returning null albums
* Fix: go to album / go to artist in Subsonic apps
* Fix: outside of window click detection

## 2.3.0 2024-01-18
* New: compatibility with applications using an OpenSubsonic compatible API
* New: `c` hotkey to clear queue
* New: `l` hotkey to toggle lyrics
* New: browse tracks by year
* New: keep track of the time tracks are added (instead of only the last modification time)
* New: IP addresses and request paths are logged for unauthenticated requests
* Improve: click outside of window to close it in player
* Improve: rewritten cover thumbnail caching to be more simple and less error-prone
* Improve: add many database indices to improve performance
* Improve: use shared HTTP client connection pool to improve performance
* Improve: hide cursor in theater mode
* Improve: longer HTTP caching for images
* Improve: controls are no longer shown in activity for clients that do not support it
* Improve: show all labels in active users/playlists chart
* Improve: add rate limit to error reports to prevent abuse
* Improve: remove dashes from authentication token to allow for easy copy pasting
* Improve: add loading spinner to browse window
* Improve: search for albums using artist name instead of only album name
* Improve: add logo to login page
* Improve: only update queue HTML when changed to fix spinner animation and to improve performance
* Improve: paginate track list to speed up latency of initial tracks shown in browse window
* Improve: automatically replace ’ with ' in metadata for consistency
* Improve: do not clear manually queued tracks when clearing the queue
* Improve: offline sync web UI: more organized progress reporting and error handling
* Fix: wrong data for "long ago" in recently chosen chart
* Fix: artist instead of album artist being used for album cover search
* Fix: empty playlists missing from dropdowns (like in "copy to playlist" function)
* Fix: radio not working in insecure contexts
* Fix: untranslated strings in /activity files table
* Fix: no progress visible in activity while paused
* Fix: last.fm account linking
* Fix: wrong artist stored in track search table (apparently, this was broken since search using sqlite was first introduced)
* Docs: add last.fm
* Docs: fix Termux installation

## 2.2.0 2024-12-25
* New: API rate limiting for MusicBrainz, Reddit, last.fm
* Improve: websocket connection now works in older browser versions
* Improve: shut down more quickly when offline sync is in progress
* Improve: animate now playing progress
* Improve: enter directory immediately after creation in the file manager
* Improve: session information (last use, user agent) is now updated periodally instead of only on login
* Improve: lock cache by key to fix double work when two requests for an uncached resource are received at the same time
* Improve: move development tasks to a Makefile
* Improve: asyncio loop debug is now only enabled in development mode
* Improve: use single database connection for cache, reducing latency
* Improve: remove annoying not-allowed cursor for disabled input fields
* Improve: retry when 503 response is received from MusicBrainz
* Improve: replace loading icon by stop icon when offline sync is stopped
* Improve: reduce number of rows in /activity/all page to improve loading speed
* Fix: new data not being visible to existing database connection in some cases
* Fix: several playing activity errors for virtual tracks
* Fix: add two missing indices in track table
* Fix: album covers not being cached
* Fix: audio fingerprinting
* Fix: now playing activity progress jumping around
* Fix: some translations (LazyString) not being included in messages file
* Fix: async loop blocking during large template renders
* Fix: incremental vacuum (removing empty space from database file) not having any effect
* Fix: error when loading charts without any tracks in the database
* Remove: AAC audio format
* Technical: add and improve tests

## 2.1.1 2024-12-15
* Fix: offline mode
* Fix: standalone download script

## 2.1.0 2024-12-13
* New: websocket control channel, provides instant playing, playback history, file changes notifications
* New: remote control from activity page
* Improve: MusicBrainz album cover selection
* Improve: offline sync UI is now much more robust and fully async
* Improve: caching is disabled in development mode (start --dev)
* Improve: audio cache is no longer discarded when metadata is changed
* Technical: merged python client with this repository

## 2.0.0 2024-12-11
* New: web UI for offline sync
* New: edit lyrics in metadata editor
* New: support for time-synced lyrics in metadata (LRC format)
* Improve: performance impact of resizing music player
* Fix: clicking on playlist checkbox labels to toggle checkbox
* Fix: fresh database creation
* Fix: album cover missing in offline mode
* Fix: lyrics setting not being saved when toggled by clicking album cover image
* Remove: profiler (will be added back later)
* Technical: rewrite using aiohttp instead of Flask and requests. This opens up the ability to use websockets in the future, without needing many worker threads. Performance should also be a bit better.
* Technical: added many tests, migrate to pytest
* Technical: many tweaks to improve performance

## 1.5.0 2024-11-23

Source code is now hosted on Codeberg. To change the Git remote, use: `git remote set-url origin https://codeberg.org/raphson/music-server.git`

The offline music player should now be installed using the `raphson_mp[offline]` package instead of the bare `raphson_mp`.

* New: theming support
* New: Windows 95 theme
* Improve: layout of forms for small screens
* Improve: player layout
* Improve: many small styling updates
* Improve: home page now adapts to wider screens
* Improve: refresh authentication cookie so it does not expire during use
* Improve: remove 'today' from last chosen chart
* Fix: PWA installation button
* Fix: volume slider is now unfocused after usage to avoid hijacking hotkeys
* Fix: Spotify artist matching was case sensitive
* Technical: add command line option to enable performance profiling
* Technical: frontend errors are now reported to the backend so bugs can be more easily identified
* Technical: API clients can now provide an authentication token via the Authorization header, and skip CSRF checks

## 1.4.0 2024-11-12
* New: compare playlist with Spotify playlist
* New: support for H264 music videos
* New: fetch lyrics from LyricFind
* Improve: music video layout
* Improve: do not show "[Instrumental]" lyrics
* Improve: layout of several forms
* Improve: last chosen chart is now per playlist
* Improve: artist similarity heatmap is no longer halved and now shows relative values
* Improve: extrapolate current position in activity
* Fix: several bugs related to music videos
* Fix: adding track without metadata to queue
* Fix: too many newlines for lyrics downloaded before v1.2.0 in offline mode
* Fix: outdated lyrics showing when page was not visible while switching tracks
* Technical: database connection is now closed properly
* Technical: added tests
* Technical: many code improvements
* Meta: repository has been moved to https://github.com/Derkades/raphson-music-player

## 1.3.0 2024-11-05
* New: playlist selection in guessing game
* New: experimental music video support
* New: setting to enable or disable lyrics
* New: download data export in account settings
* Improve: highlight current lyrics line
* Improve: automatically reload if browser loads outdated player from cache
* Improve: better sizing of cover image and lyrics box, will now take up as much screen space as possible
* Improve: remove BeautifulSoup and lxml dependency
* Improve: reduce memory usage and startup time in offline mode by only importing necessary modules
* Improve: add description to settings
* Improve: login box design
* Fix: missing play button for first track
* Fix: restore missing settings button in offline mode
* Fix: copy button missing if source playlist is not writable (source doesn't need to be writable)
* Fix: broken box shadows in music player

## 1.2.1 2024-10-26
* Improve: MusicBrainz search is more likely to find the correct cover image
* Fix: album cover from cache always being low quality
* Fix: time-synced lyrics are now available in offline-mode
* Fix: language and privacy account settings were applied for all users

## 1.2.0 2024-10-22
* New: time-synced lyrics
* New: automatic metadata lookup using AcoustID and MusicBrainz
* Fix: untranslated strings

## 1.1.0 2024-10-16

* New: add track to queue from web URL
* New: hotkey to open search
* New: artist similarity heatmap in statistics
* Improve: autofocus search field
* Improve: search UI
* Improve: switch search from trigram to unicode61 tokenizer. Misspellings are no longer tolerated, but returned results are a better match.
* Improve: restore home button to offline music player
* Improve: fixed height for queue so buttons don't jump around
* Fix: missing translations in package
* Fix: broken copy button for virtual tracks (like news)

## 1.0.1 2024-10-14

* Improve: tags UI
* Fix: lyrics extraction
* Fix: null albums in search
* Fix: missing dependencies in pypi package

## 1.0.0 2024-10-13

First release
